clear;

% trapsize = 3; bitstringlength = 42;
trapsize = 4; bitstringlength = 40;
% trapsize = 5; bitstringlength = 40;
popsize = 200;
pmut = 1/bitstringlength;

o.verbose = 1;
o.MaxFunEvals = 15000;


% Vyzkousejte vliv Uniform a 1Point krizeni
[x, fx, hist] = minEA(...
    @fBinTrap, {trapsize}, ...
    @iniBinUniform, {popsize, bitstringlength}, ...
    @selTournament, {popsize, 5}, ...
    @xoverBin1Point, {}, ...
    @mutBinSwitchBit, {pmut}, ...
    @repTruncation, {}, ...
    o);

% [ax,h1,h2] = plotyy(hist.evals, hist.fmin, hist.evals, hist.nonimpr, @steplogy, @saw);
[ax,h1,h2] = plotyy(hist.evals, hist.fmin, hist.evals, hist.fmed, @step, @step);
xlabel('evaluations');
ylabel(ax(1),'loss function - best');
ylabel(ax(2),'loss function - median');

char(hist.x+'0')