function [pop, f] = repTruncation(pop, f, offspring, foff, varargin, o)

if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end

if o.verbose,
    fprintf('Repl Truncation ');
end

popsize = length(f);

pop = [pop; offspring];
f = [f; foff];
[f, isort] = sort(f);
f = f(1:popsize);
pop = pop(isort(1:popsize),:);

if o.verbose, fprintf('done.\n'); end
