clear;

bitstringlength = 100;
popsize = 10;
pmut = 1/bitstringlength;

o.verbose = 1;
o.MaxFunEvals = 10000;

[x, fx, hist] = minEA(...
    @fBinCountOnes, {}, ...
    @iniBinUniform, {popsize, bitstringlength}, ...
    @selTournament, {popsize}, ...
    @xoverBinUniform, {}, ...
    @mutBinSwitchBit, {pmut}, ...
    @repTournamentOldVsNew, {}, ...
    o);

% [ax,h1,h2] = plotyy(hist.evals, hist.fmin, hist.evals, hist.nonimpr, @steplogy, @saw);
[ax,h1,h2] = plotyy(hist.evals, hist.fmin, hist.evals, hist.fmed, @step, @step);
xlabel('evaluations');
ylabel(ax(1),'loss function - best');
ylabel(ax(2),'loss function - median');

